<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<app-collapsible
  [appCollapsed]="false"
  [appTitle]="('settings.users.editTitle' | translate) + appSelectedUser?.firstName + ' ' + appSelectedUser?.lastName + ' (' + appSelectedUser?.userName + ')'">

  <div [formGroup]="formGroup" style="padding: 1em;">
    <div class="user-info--container">
      <div class="email">
        <span class="email--identifier">{{"settings.users.email" | translate}}</span>
        <input [formControlName]="'email'"
               [placeholder]="'settings.users.emailPlaceholder' | translate"
               [type]="'email'"
               appFormControlStatus
               class="openk-input openk-info email--input"/>

        <button (click)="deleteEmail((appSelectedUser?.id))"
                class="openk-button openk-danger department-buttons" style="margin-right: 0.7em;"
                [disabled]="!formGroup.controls['email'].value"
        >
          <mat-icon>delete</mat-icon>
          {{"shared.actions.delete" | translate}}
        </button>


        <ng-container *ngIf="appSelectedUser | appIsUserOfficialInCharge">
          <span class="email--identifier">{{"settings.users.initials" | translate}}</span>
          <input [formControlName]="'initials'"
                 [placeholder]="'settings.users.initialsPlaceholder' | translate"
                 [type]="'text'"
                 maxlength="100"
                 appFormControlStatus
                 class="openk-input openk-info email--input"/>
        </ng-container>
      </div>
      <div class="email" *ngIf="appSelectedUser | appIsUserOfficialInCharge" style="margin-left: 1em;">
        <span class="email--identifier">{{"settings.users.phone" | translate}}</span>
        <input [formControlName]="'phone'"
               [placeholder]="'settings.users.phonePlaceholder' | translate"
               [type]="'text'"
               maxlength="100"
               appFormControlStatus
               class="openk-input openk-info email--input"/>
        <span class="email--identifier">{{"settings.users.fax" | translate}}</span>
        <input [formControlName]="'fax'"
               [placeholder]="'settings.users.faxPlaceholder' | translate"
               [type]="'text'"
               maxlength="100"
               appFormControlStatus
               class="openk-input openk-info email--input"/>
      </div>
    </div>

    <ng-container *ngIf="appSelectedUser | appIsUserDivisionMember">
      <span style="font-weight: 600;">{{"settings.users.departments.title" | translate}}</span>

      <div style="margin-top: 0.5em;">
        <ng-container formArrayName="departments">
          <div *ngFor="let department of departments.controls; let i = index" class="department filter-group"
               [formGroupName]="i">
            <div class="department-selection">
              <span style="margin-right: 0.5em;">{{"settings.users.departmentGroup" | translate}}</span>
              <app-select #groupSelect
                          (appValueChange)="patchValueForDepartment(i, {name: null})"
                          [appDisabled]="appDisabled"
                          [appOptions]="appDepartments | appOptionsFromDepartmentStructure | async"
                          [appPlaceholder]="'settings.users.departmentGroupPlaceholder' | translate"
                          [formControlName]="'group'"
                          class="openk-info department--select">
              </app-select>
            </div>
            <div class="department-selection">
              <span style="margin-right: 0.5em;">{{"settings.users.department" | translate}}</span>
              <app-select
                [appDisabled]="appDisabled || ((appDepartments | appOptionsForDepartmentGroup: groupSelect.appValue).length === 0)"
                [appOptions]="appDepartments | appOptionsForDepartmentGroup: groupSelect.appValue"
                [appPlaceholder]="'settings.users.departmentPlaceholder' | translate"
                [formControlName]="'name'"
                class="openk-info department--select"
              ></app-select>
            </div>
            <div class="department-selection">
              <input #inputElement (keydown.enter)="inputElement.click()"
                     class="select-group-entry--input"
                     type="checkbox"
                     [id]="'standIn' + i"
                     [class.cursor-pointer]="!appDisabled"
                     [formControlName]="'standIn'">
              <label
                [class.cursor-pointer]="!appDisabled"
                [for]="'standIn' + i"
                class="select-group-entry--label">
                {{"settings.users.standIn" | translate}}
              </label>
            </div>
            <button (click)="deleteDepartmentEntry(i)" [disabled]="appDisabled"
                    [class.hide-button]="i <= 0"
                    class="openk-button openk-danger department-buttons" style="margin-right: 0.7em;">
              <mat-icon>delete</mat-icon>
              {{"settings.users.departments.delete" | translate}}
            </button>
          </div>
        </ng-container>
      </div>

      <div class="buttons buttons-add">
        <button (click)="addDepartmentEntry()" [disabled]="appDisabled"
                class="openk-button openk-info department-buttons" style="float: left;">
          <mat-icon>add</mat-icon>
          {{"settings.users.departments.add" | translate}}
        </button>
      </div>
    </ng-container>

    <div class="buttons">
      <button (click)="submit(appSelectedUser?.id)" [disabled]="appDisabled"
              class="openk-button openk-success">
        {{"settings.users.save" | translate}}
      </button>
    </div>
  </div>

</app-collapsible>

